#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "foto.h"
#include "readField.h"
#include "boolean.h"

#define SEP ';'

FotoList leggiFoto(char filename[])
{
    FILE *f;
    Foto readFoto;
    FotoList fList = NULL;
    boolean ok = true;
    char stato[2];

    f = fopen(filename, "r");
    if (f == NULL)
    {
        perror("File non trovato");
        return NULL;
    }

    do
    {
        initKeywordCollection(&readFoto.keywords);
        ok = readField(readFoto.nome, SEP, f) == SEP;
        ok = ok && readField(readFoto.username, SEP, f) == SEP;
        ok = ok && readField(stato, SEP, f) == SEP;
        if (ok)
        {
            readFoto.stato = stato[0];
            readKeywords(f, &readFoto.keywords);
            fList = aggiungiFoto(fList, readFoto);
        }
    }
    while (ok);
    return fList;
}

FotoList aggiungiFoto(FotoList fList, Foto foto)
{
    FotoList newElement = (FotoList)malloc(sizeof(FotoListItem));
    newElement->foto = foto;
    newElement->next = fList;
    return newElement;
}

void stampaFoto(FotoList fList)
{
    while (fList != NULL)
    {
        printf("%s - %s - %c :::", fList->foto.nome, 
            fList->foto.username, fList->foto.stato);
        printfKeywordCollection(fList->foto.keywords);
        printf("\n");
        fList = fList->next;
    }
}

int compareFoto(Foto f1, Foto f2)
{
    return strcmp(f1.nome, f2.nome);
}

FotoList insOrdFoto(FotoList fList, Foto foto)
{
    if (fList == NULL || compareFoto(foto, fList->foto) <= 0)
        return aggiungiFoto(fList, foto);
    else
    {
        fList->next = insOrdFoto(fList->next, foto);
        return fList;
    }
}

FotoList ordinaFoto(FotoList fList, char *username)
{
    FotoList newList = NULL;
    while (fList != NULL)
    {
        if (fList->foto.stato == FOTO_PUBBLICA || strcmp(fList->foto.username, username) == 0)
        {
            newList = insOrdFoto(newList, fList->foto);
        }
        fList = fList->next;
    }
    return newList;
}

boolean containsKey(KeywordCollection kc, Keyword kw)
{
    int i = 0;
    for (i = 0; i < kc.dim; i++)
        if (strcmp(kw, kc.keywordList[i]) == 0)
            return true;
    return false;
}

FotoList ricercaFoto(FotoList fList, char *username, Keyword kw)
{
    FotoList newList = NULL;
    while (fList != NULL)
    {
        if ((fList->foto.stato == FOTO_PUBBLICA || 
            strcmp(fList->foto.username, username) == 0) &&
            containsKey(fList->foto.keywords, kw))
        {
            newList = aggiungiFoto(newList, fList->foto);
        }
        fList = fList->next;
    }
    return newList;
}

void initKeywordCollection(KeywordCollection *kc)
{
    kc->dim = 0;
}

void readKeywords(FILE *f, KeywordCollection *kc)
{
    while (readField(kc->keywordList[kc->dim++], SEP, f) == SEP);
}

void printfKeywordCollection(KeywordCollection kc)
{
    int i;
    for (i = 0; i < kc.dim; i++)
        printf("%s, ", kc.keywordList[i]);
}