#include "autenticazione.h"

#ifndef FOTO
#define FOTO

#define NOME_FOTO_DIM_DI_FOTO_PER_TUTTI 16 
#define KEYWORD_DIM 16
#define KEYWORD_LIST_DIM 10

#define FOTO_PUBBLICA 'F'
#define FOTO_PRIVATA 'R'

typedef char Keyword[KEYWORD_DIM];

typedef struct keywordsstruct
{
    Keyword keywordList[KEYWORD_LIST_DIM];
    int dim;
} KeywordCollection;

typedef struct fotostruct
{
    char nome[NOME_FOTO_DIM_DI_FOTO_PER_TUTTI];
    char username[MAX_AUTH];
    char stato;
    KeywordCollection keywords;
} Foto;

typedef struct fotoliststruct
{
    Foto foto;
    struct fotoliststruct *next;
} FotoListItem;

typedef FotoListItem *FotoList;

#endif

FotoList leggiFoto(char filename[]);
FotoList aggiungiFoto(FotoList fList, Foto foto);
void stampaFoto(FotoList fList);
FotoList ordinaFoto(FotoList fList, char *username);
FotoList ricercaFoto(FotoList fList, char *username, Keyword kw);

void initKeywordCollection(KeywordCollection *kc);
void readKeywords(FILE *f, KeywordCollection *kc);
void printfKeywordCollection(KeywordCollection kc);